package ssw.mj;

import java.io.FileReader;
import java.io.IOException;
 
/** 
 * <code>Compiler</code> is the driver for the MicroJava-Compiler.
 * 
 * Execute<br>
 * <code>java ssw.mj.Compiler &lt;<i>MJ-Source-Filename</i>&gt;</code><br>
 * to start compililation.
 * 
 * @author AW
 */
public class Compiler {

	public static void main(String[] args) {
		// --- get the filename
		if (args.length < 1) { 
			System.out.println("usage: java Compiler <filename>.mj"); 
			return;
		}
		String filename = args[0];
		
		try {
			System.out.println("-----------------------------------");
			Scanner.init(new FileReader(filename));
			System.out.println("Parsing file " + filename + "\n");
			Parser.parse();
			System.out.println(Messages.getString("NO_ERRORS"));
		} catch (IOException ioe) {
		  System.out.println("File " + filename + " not found.");
		} catch (Error e) {  // handle panic mode
			String panicMode = Messages.getString("PANIC_MODE");
			if (e.getMessage().equals(panicMode)) System.out.println(panicMode);
			else throw e;
		}
	}
}
